
// 本地缓存封装
export const TaCache = {

    // 写入缓存数据，可配置有效时间(毫秒)
    set(name, value, expire = 0) {
        expire = expire > 0 ? Date.now() + expire : 0
        uni.setStorageSync(name, JSON.stringify([value, expire]))
        return value;
    },

    /* 获取缓存数据 */
    get(name, defa = null) {
        try {
            let text = uni.getStorageSync(name)
            if (!text) return defa
            let data = JSON.parse(text)
            let isExpire = (data[1] || 0) > 0 && data[1] < Date.now()
            return isExpire ? (TaCache.del(name), defa) : data[0]
        } catch (e) {
            return defa
        }
    },

    /* 删除缓存数据 */
    del(name) {
        uni.removeStorageSync(name)
    },
}
