// Toast 默认延时关闭时间
const _time_ = 2000;

// Toast 消息处理，最多显示七个汉字
export const TaToast = {

	// 隐藏消息显示
	hide() {
		uni.hideToast()
	},

	// 通用消息显示
	show(info, type = 'none', mask = true, time = _time_) {
		return new Promise(resolve => {
			setTimeout(resolve, time)
			uni.showToast({
				mask: mask || false,
				icon: type || 'none',
				title: info,
				duration: time
			})
		})
	},

	// 异常消息显示
	error(info, mask = true, time = _time_) {
		return this.show(info, 'error', mask, time)
	},

	// 成功消息显示
	success(info, mask = true, time = _time_) {
		return this.show(info, 'success', mask, time)
	},

	// 确认消息框架
	confirm(content, title = '操作确认？') {
		return new Promise((resolve, reject) => uni.showModal({
			title,
			content,
			success: (res) => (res.cancel && reject(), res.confirm && resolve(res))
		}))
	},

	// 显示加载消息
	loading(info = '', mask = true) {
		uni.showLoading({
			mask: mask,
			title: info
		})
	},

	// 隐藏加载消息
	loadhide() {
		uni.hideLoading()
	}
}